<template>
  <v-data-table
    :headers="headers"
    :items="packages"
    :search="search"  
    sort-by="precioActual"
    class="elevation-1"
  >
    <template v-slot:top >
      <v-toolbar flat color="white" margin="400px">
        <v-toolbar-title>Lista Paquetes</v-toolbar-title>
        <v-divider
          class="mx-4"
          inset
          vertical
        ></v-divider>
        

        
        <v-text-field
        v-model="search"
        append-icon="mdi-magnify"
        label="Search"
        single-line
        hide-details
        ></v-text-field>


 
        <v-spacer></v-spacer>
        <v-dialog v-model="dialog" max-width="500px">
          <v-card>
            <v-card-title>
              <span class="headline">{{ formTitle }}</span>
            </v-card-title>

            <v-card-text>
              <v-container>
                <v-row>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="editedItem.name" label="Nombre del Paquete"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="editedItem.precioActual" label="Precio Actual"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                  </v-col>
                     <v-select 
                     v-model="e7" 
                     :items="states" 
                     label="Productos"
                     menu-props="auto" 
                     multiple 
                     chips 
                     hint="Que producto deseas agrergar?" 
                     persistent-hint 
                     ></v-select>
                 <!-- <v-select v-model="e7" :items="items" label="Solo field" dense solo ></v-select> -->
                </v-row>
              </v-container>
            </v-card-text>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="#414142" text @click="close">Cancelar</v-btn>
              <v-btn color="#414142" text @click="save">Guardar</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>
    <template v-slot:item.actions="{ item }">
      <v-icon
        small
        class="mr-2"
        @click="editItem(item)"
      >
        mdi-pencil
      </v-icon>
      
      <v-icon
        small
        @click="deleteItem(item)"
      >
        mdi-delete
      </v-icon>
    </template>
    <template v-slot:no-data>
      <v-btn color="primary" @click="initialize">Reset</v-btn>
    </template>
  </v-data-table>
</template>


<script>

  export default {
    data: () => ({
      dialog: false,
      search: '',
      packages: [],//
      datos: [],
      headers: [
        {
          text: 'Nombre del Paquete',
          align: 'start',
          sortable: false,
          value: 'name',
        },
        { text: 'Precio Actual', value: 'precioActual' },
        { text: 'Productos', value: 'productosPackage' },
        { text: 'Acciones', value: 'actions', sortable: false },
      ],
      
      editedIndex: -1,
      editedItem: {
        name: '',
        precioActual: 0,
        nuevoPrecio: 0,
        productosPackage: 0,
        protein: 0,
      },
      defaultItem: {
        name: '',
        precioActual: 0,
        nuevoPrecio: 0,
        productosPackage: 0,
        protein: 0,
      },
      e7: [],
        states: [],
    }),

    computed: {
      formTitle () {
        return this.editedIndex === -1 ? 'Nuevo Paquete' : 'Editar Paquete'
      },
    },

    watch: {
      dialog (val) {
        val || this.close()
      },
    },

    created () {
      this.initialize()
    },

    methods: {
      initialize () {
          this.$axios.get(`http://${process.env.VUE_APP_API_URL}/api/packages`)
          .then(res =>{
            this.datos = res.data.data;
            this.datos.forEach(pack => {
              this.packages.push({
                id:            pack.id,
                name:          pack.info.name,
                precioActual:  pack.info.cost,
              })
            });
          })
      },
      async listarProductos(){
          this.$axios.get(`http://${process.env.VUE_APP_API_URL}/api/products`)
        .then(res => {res.data.data.forEach(product => {
            console.log(product);
            product.products.forEach(product2 => {
              this.states.push(
                product2.info.product_name,
           );
          });    
          });console.log(this.datos);
        });
      },

      editItem (item) {
        this.editedIndex = this.packages.indexOf(item)
        this.editedItem = Object.assign({}, item)
        this.dialog = true
      },

      deleteItem (item) {
        console.log(item.id)
        confirm('Desea eliminar este Producto?') && 
        this.$axios
        .post(`http://${process.env.VUE_APP_API_URL}/api/packages/delete`, {uid:item.id})
        .then(res => {
          console.log(res);
        });
      },

      close () {
        this.dialog = false
        setTimeout(() => {
          this.editedItem = Object.assign({}, this.defaultItem)
          this.editedIndex = -1
        }, 300)
      },

      save () {
        if (this.editedIndex > -1) {
          Object.assign(this.packages[this.editedIndex], this.editedItem)
        } else {
          this.packages.push(this.editedItem)
        }
        this.close()
      },
    },
  }
</script>

<style scoped>
.elevation-1 {
  margin: 2%;
  border-radius: 10px;
}
</style>


